/*


  2.0furil/momoko03 Copyright (c) 1995 Wedding-applepop.
  $Id: peach.c,v 1.14 1995-08-27 00:33:10+0900 applepop Exp $


														 Momoko@Hanasaki
*/

#include "lily.h"


  RCSID "$Id: peach.c,v 1.14 1995-08-27 00:33:10+0900 applepop Exp $" ;


	WEDDING	*something4[ FURIL ] ;
	JULIET	Juliet ;


/*

*/

void main( int argc, char **argv )
{

	initialize() ;

	if ( ! check_option( argc, argv ) )
		search_files( "*.*" ) ;

	if ( ! read_filexfer() ) {
		exit( 1 ) ;
	} else {
		make_script() ;
		exit( 0 ) ;
	}

}

/*

*/

void initialize( void )
{

	strcpy( Juliet.outfile, "" );
	strcpy( Juliet.logfile, "filexfer.log" );

}

/*

*/

int check_option( int argc, char **argv )
{

	int		i, j, c ;
	int		endflag ;
	int		paramode = 0 ;
	int		entry = FALSE ;


	while ( --argc ) {
		if ( **++argv == '-' && *( *argv + 1 ) ) {
			paramode = 0 ;
			endflag = FALSE ;

			while ( ! endflag ) {
				c = tolower( *++*argv ) ;
				switch( c ) {
				case 'l':
					endflag = TRUE ;
					if ( ! *( *argv + 1 ) )
						paramode = 1 ;
					else
						strcpy( Juliet.logfile, ++*argv ) ;
					break ;
				case 'o':
					endflag = TRUE ;
					if ( ! *( *argv + 1 ) )
						paramode = 2 ;
					else
						strcpy( Juliet.outfile, ++*argv ) ;
					break ;
				case 'h':
				case '?':
					usage() ;
					exit( 0 ) ;
					break ;
				case '-':
					break ;
				case 0:
					endflag = TRUE ;
					continue ;
				default:
					usage() ;
					fprintf( stderr,
						"-%c ͂! Ȃ̃E\! E\!\n",
						**argv
					) ;
					exit( 1 ) ;
					break ;
				}
			}
		} else {
			switch( paramode ) {
				case 0:
					search_files ( *argv ) ;
					entry = TRUE ;
					break ;
				case 1:
					strcpy( Juliet.logfile, *argv ) ;
					break ;
				case 2:
					strcpy( Juliet.outfile, *argv ) ;
					break ;
				default:
					break ;
			}
			paramode = 0 ;
		}
	}

	return entry ;

}

/*

*/

void search_files( char *name )
{

	struct _filbuf filbuf ;


	if ( _dos_files( &filbuf, name, 0x20 ) >= 0 ) {
		do {
			hashadd( filbuf.name ) ;
		} while ( _dos_nfiles( &filbuf ) >= 0 ) ;
	}

}

/*

*/

int read_filexfer( void )
{
	char	readbuf[ 120 ] ;
	char	filename[ 23 ] ;
	char	*p1, *p2 ;
	int		marked = FALSE ;

	FILE	*fp ;
	WEDDING	*wedding ;


	if ( ( fp = fopen( Juliet.logfile, "rt" ) ) == NULL ) {
		fprintf( stderr,
			"%s  ɂꂿ\n", Juliet.logfile
		) ;
		exit( 1 ) ;
	}

	while( fgets( readbuf, 113, fp ) ) {
		if ( strlen( readbuf ) != 112 && strlen( readbuf ) != 111 ) {
			continue ;
		}
		readbuf[ 60 ] = 0 ;

		p1 = &readbuf[ 38 ] ;
		p2 = filename ;

		while ( *p1 && *p1 != ' ' ) {
			*p2++ = *p1++ ;
		}
		*p2 = 0 ;

		strlwr( filename );
		wedding = search( something4[ hash( filename ) ], filename ) ;
		if ( wedding ) {
			wedding->daisy = marked = TRUE ;
		}
	}
	fclose( fp ) ;

	return marked ;
}

/*

*/

void make_script( void )
{

	int		i ;
	int		begin = FALSE ;

	WEDDING	*wedding ;
	FILE	*fp ;


	if ( ! strlen( Juliet.outfile ) ) {
		fp = stdout ;
	} else {
		if ( ( fp = fopen( Juliet.outfile, "wt" ) ) == NULL ) {
			fprintf( stderr,
				"%s  ɂꂿ\n", Juliet.outfile
			) ;
			exit( 1 ) ;
		}
	}

	fprintf( fp,
			"#!madoka\n#\n"
			"# 2.0furil/momoko03 filexfer filemark\n"
			"# Copyright (c) 1995 Wedding-applepop.\n"
			"# ς tς.\n\n"
			"\t-\t\\\n"
	) ;

	for ( i = 0; i < FURIL; i++ ) {
		wedding = something4[i];

		while( wedding != NULL ) {
			if ( wedding->daisy ) {
				if ( begin )
					fprintf( fp, " ;\n" ) ;
				else
					begin = TRUE ;

				if ( fprintf( fp, "\t&mark %s",
					wedding->peach ) == EOF ) {
					fclose( fp ) ;
					fprintf( stderr,
						"%s   ł?!\n", Juliet.outfile
					) ;
					exit( 1 ) ;
				}
			}
			wedding = wedding->lily;
		}
	}

	fprintf( fp, "\n\n") ;

	if ( strlen( Juliet.outfile ) ) {
		fclose( fp ) ;
	}

}

/*

												Wedding beautiful flower
*/
